﻿// ------------------------------------------------------------------------------------
//
// Dreipunkt                                                     Ulrich Müller 24.11.09
//                                                               Aspire C# 2005 Express
// Dreipunktregelung über die Werte eines Photowiderstandes
// EncoderMotor an M1, Lampe an O7, Photowiderstand an I4
//
// ------------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using FishFaceTX;

namespace Dreipunkt {
  public partial class DreiMain : Form {
    FishControl   fc = new FishControl();
    EncoderMotor  ReglerMotor;
    PhotoResistor LichtSensor;
    Lamp          Lichtquelle;

    public DreiMain() {
      InitializeComponent();
      Label.CheckForIllegalCrossThreadCalls = false;
      ReglerMotor                  = new EncoderMotor(fc, Ctr.Main, Mot.M1);
      LichtSensor                  = new PhotoResistor(fc, true, Ctr.Main, Unv.I4);
      LichtSensor.ChangedToHigh   += new AnalogInput.Limit(LichtSensor_ChangedToHigh);
      LichtSensor.ChangedToLow    += new AnalogInput.Limit(LichtSensor_ChangedToLow);
      LichtSensor.ChangedToNormal += new AnalogInput.Limit(LichtSensor_ChangedToNormal);
      LichtSensor.CurrentValue    += new AnalogInput.Limit(LichtSensor_CurrentValue);
      Lichtquelle                  = new Lamp(fc, Ctr.Main, Out.O7);
    }

    void LichtSensor_ChangedToHigh(AnalogInput sender, int Wert) {
      ReglerMotor.RunLeft(444);
    }
    void LichtSensor_ChangedToLow(AnalogInput sender, int Wert) {
      ReglerMotor.RunRight(444);
    }
    void LichtSensor_ChangedToNormal(AnalogInput sender, int Wert) {
      ReglerMotor.StopRun();
    }
    void LichtSensor_CurrentValue(AnalogInput sender, int Wert) {
      lblIstWert.Text = Wert.ToString();
    }
    private void numSollwert_ValueChanged(object sender, EventArgs e) {
      int SollWert          = (int)numSollwert.Value;
      LichtSensor.LimitHigh = SollWert + 75;
      LichtSensor.LimitLow  = SollWert - 75;
    }

    private void cmdAction_Click(object sender, EventArgs e) {
      numSollwert.Value = 700;
      fc.Connect("COM4");
      fc.StartEvents();
      Lichtquelle.On();
      fc.Pause(1234);
      lblStatus.Text = "Ende : ESC-Taste";
      while (!fc.Finish()) fc.Pause(555);
      fc.DisConnect();
      lblStatus.Text = "Das war's";
    }
  }
}