﻿// --------------------------------------------------------------------------------------
//
// DualOutput.CS                                                   Ulrich Müller 31.10.09
//                                                                 Aspire C# 2005 Express
// Basis für Devices, die zweipolig an M-Ausgänge angeschlossen sind
//       Vorzugsweise Motoren, Lampen ... gelten als einpolig angeschlossen -> MonoOut
//
// --------------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Text;

namespace FishFaceTX {
  public class DualOutput : DeviceBase {
    protected Dir stateValue;

    public DualOutput(FishControl fc, Ctr ctrId, Mot OutputName)
      : this(fc, false, ctrId, OutputName) {
    }
    public DualOutput(FishControl fc, bool WithEvents, Ctr ctrId, Mot OutputName)
      : base(fc, WithEvents, (int)ctrId, (int)OutputName) {
      base.deviceType = "Mot";
      this.stateValue = Dir.Off;
    }
    public override string ConnectorName {
      get {
        return ((Mot)base.connectorNumber).ToString();
      }
    }
    public Dir State {
      get {
        return stateValue;
      }
    }
    protected override void EventLoop() {
    }

    public void On() {
      this.Left();
    }
    public void On(int speed) {
      this.Left(speed);
    }
    public void Left() {
      this.Left(512);
    }
    public void Left(int speed) {
      tx.SetMotor((Ctr)base.controllerNumber,(Mot)base.connectorNumber, 
        Dir.Left, speed);
      stateValue = Dir.Left;
    }
    public void Right() {
      this.Right(512);
    }
    public void Right(int speed) {
      tx.SetMotor((Ctr)base.controllerNumber, (Mot)base.connectorNumber,
        Dir.Right, speed);
      stateValue = Dir.Right;
    }
    public void Off() {
      tx.SetMotor((Ctr)base.controllerNumber, (Mot)base.connectorNumber, Dir.Off);
      stateValue = Dir.Off;
    }
    public void Go(Dir dir) {
      this.Go(dir, 512);
    }
    public void Go(Dir dir, int speed) {
      tx.SetMotor((Ctr)base.controllerNumber, (Mot)base.connectorNumber,
        dir, speed);
      stateValue = dir;
    }
  }
}
